<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Login</title>
</head>
<body>
    <div class="container">
        <div class="d-flex justify-content-center mt-5 pt-5" >
            <div class="card w-50 p-4">
                <div class="card-body">
                    <h3 class="text-center mb-4">Login to your account</h3>
                    <div class="form-group">
                        <input id="inp-username" type="text" class="form-control" placeholder="Username">
                    </div>

                    <div class="form-group">
                        <input id="inp-password" type="password" class="form-control" placeholder="Password">
                    </div>

                    <div class="form-group">
                        <input id="checkbox-remember" type="checkbox">
                        <label for="">Remember account</label>
                    </div>
                    <button id="btn-login" class="btn btn-primary w-100">Login</button>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    const token = getCookie("token");

    if(token) {
        window.location.href = "info.html";
    }
    $("#btn-login").on("click", function() {
        onBtnLoginClick();
    })
    // Hàm xử lý sự kiện nhấn nút sign up
    function onBtnLoginClick() {
        var vDataLogin = {
            username: "",
            password: "",
            remember: false
        }

        getDataLogin(vDataLogin);
        console.log(vDataLogin);
        var vValidate = validateData(vDataLogin);
        if(vValidate) {
            callApiToLogin(vDataLogin);
        }
    }

    //Hàm lấy data từ form
    function getDataLogin(paramData) {
       paramData.username = $("#inp-username").val();
       paramData.password = $("#inp-password").val();
       paramData.remember = $('#checkbox-term').is(":checked")
    }

    // Hàm validate dữ liệu
    function validateData(paramData) {
        if(paramData.username == "") {
            alert("Vui lòng nhập username");
            return false;
        }

        if(paramData.password == "") {
            alert("Vui lòng nhập mật khẩu!");
            return false;
        }

        return true;
    }

    // Hàm gọi API để tạo mới tài khoản
    function callApiToLogin(paramData) {
        var vData = {
            username: paramData.username,
            password: paramData.password
        }

        $.ajax({
            type: "POST",
            url: "http://localhost:8080/api/auth/signin",
            contentType: "application/json",
            data: JSON.stringify(vData),
            success: function(paramRes) {
                alert("Đăng nhập thành công!");
                console.log(paramRes);
                responseHandler(paramRes);
            },
            error: function(paramError) {
                alert("Tên người dùng hoặc mật khẩu chưa chính xác!");
                console.log(paramError.status);
            }
        })
    }

    //Xử lý object trả về khi login thành công
    function responseHandler(data) {
        //Lưu token vào cookie trong 1 ngày
        setCookie("token", data.accessToken, 1);

        window.location.href = "info.html";
    }

    //Hàm setCookie đã giới thiệu ở bài trước
    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    //Hàm get Cookie đã giới thiệu ở bài trước
    function getCookie(cname) {
        var name = cname + "=";
        var decodedCookie = decodeURIComponent(document.cookie);
        var ca = decodedCookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    }
</script>
</html>